using System;
using System.Diagnostics;
using System.IO;
using Microsoft.WindowsAzure.Diagnostics;
using Microsoft.WindowsAzure.ServiceRuntime;

namespace HeuristicLab.Services.Hive.WebRole {
  public class AzureLocalStorageTraceListener : XmlWriterTraceListener {
    public AzureLocalStorageTraceListener()
      : base(Path.Combine(AzureLocalStorageTraceListener.GetLogDirectory().Path, "HeuristicLab.Services.Hive.WebRole.svclog")) {
    }

    public static DirectoryConfiguration GetLogDirectory() {
      DirectoryConfiguration directory = new DirectoryConfiguration();
      directory.Container = "wad-tracefiles";
      directory.DirectoryQuotaInMB = 10;
      directory.Path = RoleEnvironment.GetLocalResource("HeuristicLab.Services.Hive.WebRole.svclog").RootPath;
      return directory;
    }
  }
}
